-- Old Instance Finder - DrKazza

--Declare Addon and libraries
local OldInstanceFinder = LibStub("AceAddon-3.0"):NewAddon("OldInstanceFinder", "AceConsole-3.0", "AceTimer-3.0")
local OIF = OldInstanceFinder
local wholib = LibStub:GetLibrary("LibWho-2.0"):Library()
local BZ = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local L = LibStub("AceLocale-3.0"):GetLocale("OldInstanceFinder")
local maxlevel = 85


-- Specify Dungeons... to add a dungeon to the searchlist just remove the two dashes in front of its name "--"
-- likewise to exclude one from the search add two dashes.  --
local SearchList = { 
--	BZ["Ragefire Chasm"],				-- level guide 16
--	BZ["Wailing Caverns"],				-- level guide 18
--	BZ["The Deadmines"],				-- level guide 20
--	BZ["Shadowfang Keep"],				-- level guide 22
--	BZ["The Stockade"],				-- level guide 24
--	BZ["Blackfathom Deeps"],			-- level guide 24
--	BZ["Razorfen Kraul"],				-- level guide 26
--	BZ["Gnomeregan"],					-- level guide 30
--	BZ["Razorfen Downs"],				-- level guide 36
--	BZ["Scarlet Monastery"], 			-- level guide 36		-- Check instance specifics
--	BZ["Uldaman"],					-- level guide 40
--	BZ["Zul'Farrak"],					-- level guide 44
--	BZ["Maraudon"],					-- level guide 47
--	BZ["The Temple of Atal'Hakkar"], 		-- level guide 50		-- Check instance specifics
--	BZ["Dire Maul"], 					-- level guide 52		-- Check instance specifics	
--	BZ["Blackrock Depths"],				-- level guide 54
--	BZ["Scholomance"],				-- level guide 55
--	BZ["Blackrock Spire"], 				-- level guide 58		-- Check instance specifics		
--	BZ["Stratholme"],					-- level guide 59
	BZ["Zul'Gurub"],					-- level guide 59
      BZ["Molten Core"],				-- level guide 60
      BZ["Blackwing Lair"], 				-- level guide 60
--	BZ["Ruins of Ahn'Qiraj"],			-- level guide 60
      BZ["Temple of Ahn'Qiraj"], 			-- level guide 60
      BZ["Hellfire Ramparts"], 			-- level guide 61
      BZ["The Blood Furnace"], 			-- level guide 62
--	BZ["The Slave Pens"],				-- level guide 62
--	BZ["The Underbog"],				-- level guide 64
--	BZ["Mana-Tombs"],					-- level guide 65
      BZ["Auchenai Crypts"],				-- level guide 66
      BZ["Old Hillsbrad Foothills"], 		-- level guide 67
      BZ["Sethekk Halls"], 				-- level guide 68
--	BZ["The Steamvault"],				-- level guide 69
      BZ["Shadow Labyrinth"], 			-- level guide 69
      BZ["The Shattered Halls"], 			-- level guide 70
      BZ["The Black Morass"], 			-- level guide 70
      BZ["The Botanica"], 				-- level guide 70
      BZ["The Mechanar"], 				-- level guide 70
      BZ["The Arcatraz"], 				-- level guide 70
      BZ["Magisters' Terrace"], 			-- level guide 70
      BZ["Karazhan"], 					-- level guide 70
--	BZ["Gruul's Lair"],				-- level guide 70
--	BZ["Magtheridon's Lair"],			-- level guide 70
      BZ["Zul'Aman"], 					-- level guide 70
      BZ["Serpentshrine Cavern"], 			-- level guide 70
      BZ["The Eye"], 					-- level guide 70
      BZ["Hyjal Summit"],				-- level guide 70
      BZ["Black Temple"], 				-- level guide 70
--	BZ["Sunwell Plateau"],				-- level guide 70
--	BZ["Utgarde Keep"],				-- level guide 71
--	BZ["The Nexus"],					-- level guide 72
--	BZ["Azjol-Nerub"],				-- level guide 73
--	BZ["Ahn'kahet: The Old Kingdom"],		-- level guide 74
--	BZ["Drak'Tharon Keep"],				-- level guide 75
--	BZ["The Violet Hold"],				-- level guide 76
--	BZ["Gundrak"],					-- level guide 77
--	BZ["Halls of Stone"],				-- level guide 78
--	BZ["Halls of Lightning"],			-- level guide 80
--	BZ["The Oculus"],					-- level guide 80
--	BZ["The Culling of Stratholme"], 		-- level guide 80		-- Check instance specifics
--	BZ["Utgarde Pinnacle"],				-- level guide 80
--	BZ["Trial of the Champion"],			-- level guide 80
--	BZ["The Forge of Souls"],			-- level guide 80
--	BZ["Pit of Saron"],				-- level guide 80
--	BZ["Halls of Reflection"],			-- level guide 80
      BZ["Naxxramas"], 					-- level guide 80
--	BZ["The Obsidian Sanctum"],			-- level guide 80
--	BZ["The Eye of Eternity"], 			-- level guide 80		-- will this throw an false positive when searching for "The Eye"?
	BZ["Onyxia's Lair"],				-- level guide 80
      BZ["Ulduar"], 					-- level guide 80
--	BZ["Trial of the Crusader"],			-- level guide 80
--	BZ["Vault of Archavon"],			-- level guide 80
--	BZ["Icecrown Citadel"],				-- level guide 80



-- Things that need checking below
--	BZ["Upper Blackrock Spire"], --?? is this actually a zone or is it just Blackrock Spire?
--	BZ["Sunken Temple"],	--?? is this actually a zone or just the area outside the instance?
--	BZ["Lower Blackrock Spire"], --?? is this actually a zone or is it just Blackrock Spire?
--	BZ["Dire Maul (East)"],  --?? is this an instance?
--	BZ["Dire Maul (North)"],  --?? is this an instance?
--	BZ["Dire Maul (West)"],  --?? is this an instance?
--	BZ["Armory"], --?? is this an instance?
--	BZ["Cathedral"], --?? is this an instance?
--	BZ["Graveyard"], --?? is this an instance?
--	BZ["Library"], --?? is this an instance?
--	BZ["Old Stratholme"], --?? is this an intance?

};

function OIF:OnInitialize()
    OIF:RegisterChatCommand("OIF", "Slash")
    OIF:RegisterChatCommand("OldInstanceFinder", "Slash")
end

function OIF:OnEnable()
-- STOP THE SPAM, this was only used for debugging anyway
-- OIF:Print(L["Load"])
end

function OIF:Slash(msg)
    if msg then
        if tonumber(msg) then
		-- Arguement is a number, searching for a specific level
            OIF:StartSearch(msg)
            return;
	  else 
		local lookforplus = string.find(msg, "%+")
		if lookforplus then
			-- Arguement has a + so look for the digits preceeding it and search to max level
			_, _, minlevel = string.find(msg, "(%d+)%+")
			if tonumber(minlevel) then
		            OIF:StartSearch(minlevel, maxlevel)
            		    return;
			else
				-- The digits preceeding the + were not a number - return usage message
			      OIF:Usage()
			end
		end

		local lookforminus = string.find(msg, "%-")
		local lowerlvl
		local upperlvl
		if lookforminus then
			-- Arguement has a - so look for the digits preceeding and following it
			_, _, lowerlvl, upperlvl = string.find(msg, "(%d+)%-(%d+)")
			if tonumber(lowerlvl) and tonumber(upperlvl) then
		            OIF:StartSearch(lowerlvl, upperlvl)				
            		    return;
			else
				-- The digits preceeding and following the - were not numbers - return usage message
			      OIF:Usage()
			end
		end
        end
    end
    OIF:Usage()
end

function OIF:Usage()
    OIF:Print(L["Usage"])
end

local isranged
function OIF:StartSearch(a, ...)

if ... then
	isranged = true
	lvlstring = a.."-".. ...
else
OIF:Print("arg = 0")
	-- only one arguement passed therefore search for one level only
	isranged = false
	lvlstring = a
end

    OIF:Print((L["Startsearch"]):format(#SearchList))
    for i=1, #SearchList do
    searchquery = 'z-'..SearchList[i]..' '..lvlstring

    local searchresult = wholib:Who(
             searchquery,
         {
             queue = wholib.WHOLIB_QUEUE_SCANNING,
             --flags = whoLib.WHOLIB_FLAG_ALWAYS_CALLBACK,   -- not sure what this does but it works without it!
             callback = self.CatchWhoResults
         });
         if(searchresult) then
             self.CatchWhoResults(searchresult);
         end
    end
end

function OIF:CatchWhoResults(results, complete)
    if results == nil or #results == 0 then
        -- no one in this dungeon
    else
        currentzone = results[1].Zone;
        level = results[1].Level;
        numofrunners = #results;

		if complete then
			if numofrunners == 1 then
				OIF:Print((L["OneHit"]) :format(level, currentzone));
			else
				if isranged then
					OIF:Print((L["MoreHitsRange"]) :format(numofrunners, currentzone))
				else
					OIF:Print((L["MoreHits"]) :format(numofrunners, level, currentzone))
				end
			end
		else
			if isranged then
				OIF:Print((L["LotsHitsRange"]) :format(currentzone))
			else
				OIF:Print((L["LotsHits"]) :format(level, currentzone))
			end
		end
    end
end